diff --git a/sys/dev/acpica5/acpi_cpu_pstate.c b/sys/dev/acpica5/acpi_cpu_pstate.c
index 5e436c8..7ba69ad 100644
--- a/sys/dev/acpica5/acpi_cpu_pstate.c
+++ b/sys/dev/acpica5/acpi_cpu_pstate.c
@@ -939,7 +939,7 @@ acpi_pst_check_csr(struct acpi_pst_softc *sc)
 	if (acpi_pst_md == NULL)
 		return 0;
 
-	netmsg_init(&msg.nmsg, &curthread->td_msgport,
+	netmsg_init(&msg.nmsg, NULL, &curthread->td_msgport,
 		    MSGF_MPSAFE | MSGF_PRIORITY,
 		    acpi_pst_check_csr_handler);
 	msg.ctrl = &sc->pst_creg;
@@ -965,7 +965,7 @@ acpi_pst_check_pstates(struct acpi_pst_softc *sc)
 	if (acpi_pst_md == NULL)
 		return 0;
 
-	netmsg_init(&nmsg, &curthread->td_msgport,
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
 		    MSGF_MPSAFE | MSGF_PRIORITY,
 		    acpi_pst_check_pstates_handler);
 
@@ -990,7 +990,7 @@ acpi_pst_init(struct acpi_pst_softc *sc)
 	if (acpi_pst_md == NULL)
 		return 0;
 
-	netmsg_init(&msg.nmsg, &curthread->td_msgport,
+	netmsg_init(&msg.nmsg, NULL, &curthread->td_msgport,
 		    MSGF_MPSAFE | MSGF_PRIORITY, acpi_pst_init_handler);
 	msg.ctrl = &sc->pst_creg;
 	msg.status = &sc->pst_sreg;
@@ -1021,7 +1021,7 @@ acpi_pst_set_pstate(struct acpi_pst_softc *sc, const struct acpi_pstate *pstate)
 			      pstate->st_freq);
 	}
 
-	netmsg_init(&msg.nmsg, &curthread->td_msgport,
+	netmsg_init(&msg.nmsg, NULL, &curthread->td_msgport,
 		    MSGF_MPSAFE | MSGF_PRIORITY,
 		    acpi_pst_set_pstate_handler);
 	msg.nmsg.nm_lmsg.u.ms_resultp = __DECONST(void *, pstate);
@@ -1051,7 +1051,7 @@ acpi_pst_get_pstate(struct acpi_pst_softc *sc)
 	if (acpi_pst_md == NULL)
 		return 0;
 
-	netmsg_init(&msg.nmsg, &curthread->td_msgport,
+	netmsg_init(&msg.nmsg, NULL, &curthread->td_msgport,
 		    MSGF_MPSAFE | MSGF_PRIORITY,
 		    acpi_pst_get_pstate_handler);
 	msg.status = &sc->pst_sreg;
diff --git a/sys/dev/netif/iwl/if_iwl.c b/sys/dev/netif/iwl/if_iwl.c
index 847f9b3..7049c7f 100644
--- a/sys/dev/netif/iwl/if_iwl.c
+++ b/sys/dev/netif/iwl/if_iwl.c
@@ -534,7 +534,7 @@ void
 iwlmsg_init(struct iwlmsg *msg, struct lwkt_port *rport, netisr_fn_t dispatch,
 	    void *sc)
 {
-	netmsg_init(&msg->iwlm_nmsg, rport, 0, dispatch);
+	netmsg_init(&msg->iwlm_nmsg, NULL, rport, 0, dispatch);
 	msg->iwlm_softc = sc;
 }
 
diff --git a/sys/kern/kern_poll.c b/sys/kern/kern_poll.c
index d4371c0..1504b37 100644
--- a/sys/kern/kern_poll.c
+++ b/sys/kern/kern_poll.c
@@ -257,14 +257,14 @@ init_device_poll_pcpu(int cpuid)
 	pctx->poll_cpuid = cpuid;
 	poll_reset_state(pctx);
 
-	netmsg_init(&pctx->poll_netmsg, &netisr_adone_rport, MSGF_MPSAFE,
-		    netisr_poll);
+	netmsg_init(&pctx->poll_netmsg, NULL, &netisr_adone_rport,
+		    MSGF_MPSAFE, netisr_poll);
 #ifdef INVARIANTS
 	pctx->poll_netmsg.nm_lmsg.u.ms_resultp = pctx;
 #endif
 
-	netmsg_init(&pctx->poll_more_netmsg, &netisr_adone_rport, MSGF_MPSAFE,
-		    netisr_pollmore);
+	netmsg_init(&pctx->poll_more_netmsg, NULL, &netisr_adone_rport,
+		    MSGF_MPSAFE, netisr_pollmore);
 #ifdef INVARIANTS
 	pctx->poll_more_netmsg.nm_lmsg.u.ms_resultp = pctx;
 #endif
@@ -341,8 +341,8 @@ sysctl_pollhz(SYSCTL_HANDLER_ARGS)
 	else if (phz > DEVICE_POLLING_FREQ_MAX)
 		phz = DEVICE_POLLING_FREQ_MAX;
 
-	netmsg_init(&msg, &curthread->td_msgport, MSGF_MPSAFE,
-		    poll_sysctl_pollhz);
+	netmsg_init(&msg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, poll_sysctl_pollhz);
 	msg.nm_lmsg.u.ms_result = phz;
 
 	port = cpu_portfn(pctx->poll_cpuid);
@@ -366,8 +366,8 @@ sysctl_polling(SYSCTL_HANDLER_ARGS)
 	if (error || req->newptr == NULL)
 		return error;
 
-	netmsg_init(&msg, &curthread->td_msgport, MSGF_MPSAFE,
-		    poll_sysctl_polling);
+	netmsg_init(&msg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, poll_sysctl_polling);
 	msg.nm_lmsg.u.ms_result = enabled;
 
 	port = cpu_portfn(pctx->poll_cpuid);
@@ -389,8 +389,8 @@ sysctl_regfrac(SYSCTL_HANDLER_ARGS)
 	if (error || req->newptr == NULL)
 		return error;
 
-	netmsg_init(&msg, &curthread->td_msgport, MSGF_MPSAFE,
-		    poll_sysctl_regfrac);
+	netmsg_init(&msg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, poll_sysctl_regfrac);
 	msg.nm_lmsg.u.ms_result = reg_frac;
 
 	port = cpu_portfn(pctx->poll_cpuid);
@@ -416,8 +416,8 @@ sysctl_burstmax(SYSCTL_HANDLER_ARGS)
 	else if (burst_max > MAX_POLL_BURST_MAX)
 		burst_max = MAX_POLL_BURST_MAX;
 
-	netmsg_init(&msg, &curthread->td_msgport, MSGF_MPSAFE,
-		    poll_sysctl_burstmax);
+	netmsg_init(&msg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, poll_sysctl_burstmax);
 	msg.nm_lmsg.u.ms_result = burst_max;
 
 	port = cpu_portfn(pctx->poll_cpuid);
@@ -439,8 +439,8 @@ sysctl_eachburst(SYSCTL_HANDLER_ARGS)
 	if (error || req->newptr == NULL)
 		return error;
 
-	netmsg_init(&msg, &curthread->td_msgport, MSGF_MPSAFE,
-		    poll_sysctl_eachburst);
+	netmsg_init(&msg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, poll_sysctl_eachburst);
 	msg.nm_lmsg.u.ms_result = each_burst;
 
 	port = cpu_portfn(pctx->poll_cpuid);
@@ -766,7 +766,8 @@ ether_pollcpu_register(struct ifnet *ifp, int cpuid)
 		ifp->if_poll(ifp, POLL_REGISTER, 0);
 	ifnet_deserialize_all(ifp);
 
-	netmsg_init(&msg, &curthread->td_msgport, MSGF_MPSAFE, poll_register);
+	netmsg_init(&msg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, poll_register);
 	msg.nm_lmsg.u.ms_resultp = ifp;
 
 	port = cpu_portfn(cpuid);
@@ -859,7 +860,8 @@ ether_poll_deregister(struct ifnet *ifp)
 	ifp->if_poll_cpuid = -1;
 	ifnet_deserialize_all(ifp);
 
-	netmsg_init(&msg, &curthread->td_msgport, MSGF_MPSAFE, poll_deregister);
+	netmsg_init(&msg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, poll_deregister);
 	msg.nm_lmsg.u.ms_resultp = ifp;
 
 	port = cpu_portfn(cpuid);
diff --git a/sys/kern/kern_timeout.c b/sys/kern/kern_timeout.c
index 91ebfae..6351326 100644
--- a/sys/kern/kern_timeout.c
+++ b/sys/kern/kern_timeout.c
@@ -486,6 +486,9 @@ callout_stop(struct callout *c)
  * Prepare a callout structure for use by callout_reset() and/or 
  * callout_stop().  The MP version of this routine requires that the callback
  * function installed by callout_reset() be MP safe.
+ *
+ * The init functions can be called from any cpu and do not have to be
+ * called from the cpu that the timer will eventually run on.
  */
 void
 callout_init(struct callout *c)
diff --git a/sys/kern/uipc_msg.c b/sys/kern/uipc_msg.c
index c117e38..0340daf 100644
--- a/sys/kern/uipc_msg.c
+++ b/sys/kern/uipc_msg.c
@@ -59,15 +59,12 @@ void
 so_pru_abort(struct socket *so)
 {
 	struct netmsg_pru_abort msg;
-	lwkt_port_t port;
 
 	KKASSERT(so->so_state & SS_ABORTING);
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_ABORT);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport,
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
 		    0, netmsg_pru_abort);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_abort;
-	msg.nm_so = so;
-	(void)lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	(void)lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 }
 
 /*
@@ -80,16 +77,13 @@ void
 so_pru_aborta(struct socket *so)
 {
 	struct netmsg_pru_abort *msg;
-	lwkt_port_t port;
 
 	KKASSERT(so->so_state & SS_ABORTING);
 	msg = kmalloc(sizeof(*msg), M_LWKTMSG, M_WAITOK | M_ZERO);
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_ABORT);
-	netmsg_init(&msg->nm_netmsg, &netisr_afree_rport,
+	netmsg_init(&msg->nm_netmsg, so, &netisr_afree_rport,
 		    0, netmsg_pru_abort);
 	msg->nm_prufn = so->so_proto->pr_usrreqs->pru_abort;
-	msg->nm_so = so;
-	lwkt_sendmsg(port, &msg->nm_netmsg.nm_lmsg);
+	lwkt_sendmsg(so->so_port, &msg->nm_netmsg.nm_lmsg);
 }
 
 /*
@@ -113,15 +107,12 @@ so_pru_accept(struct socket *so, struct sockaddr **nam)
 #ifdef notdef
 	int error;
 	struct netmsg_pru_accept msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_ACCEPT);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_accept);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_accept);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_accept;
-	msg.nm_so = so;
 	msg.nm_nam = nam;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 #endif
 }
@@ -131,35 +122,34 @@ so_pru_attach(struct socket *so, int proto, struct pru_attach_info *ai)
 {
 	int error;
 	struct netmsg_pru_attach msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(NULL, NULL, NULL, PRU_ATTACH);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_attach);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_attach);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_attach;
-	msg.nm_so = so;
 	msg.nm_proto = proto;
 	msg.nm_ai = ai;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
+/*
+ * NOTE: If the target port changes the bind operation will deal with it.
+ */
 int
 so_pru_bind(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
 	int error;
 	struct netmsg_pru_bind msg;
-	lwkt_port_t port;
 
-	/* Send mesg to thread for new address. */
-	port = so->so_proto->pr_mport(NULL, nam, NULL, PRU_BIND);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_bind);
+#if 0
+	port = so->so_proto->pr_mport(NULL, nam, NULL);
+#endif
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_bind);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_bind;
-	msg.nm_so = so;
 	msg.nm_nam = nam;
 	msg.nm_td = td;		/* used only for prison_ip() XXX JH */
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
@@ -168,16 +158,13 @@ so_pru_connect(struct socket *so, struct sockaddr *nam, struct thread *td)
 {
 	int error;
 	struct netmsg_pru_connect msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, nam, NULL, PRU_CONNECT);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_connect);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_connect);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_connect;
-	msg.nm_so = so;
 	msg.nm_nam = nam;
 	msg.nm_td = td;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
@@ -186,38 +173,33 @@ so_pru_connect2(struct socket *so1, struct socket *so2)
 {
 	int error;
 	struct netmsg_pru_connect2 msg;
-	lwkt_port_t port;
 
-	port = so1->so_proto->pr_mport(so1, NULL, NULL, PRU_CONNECT2);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_connect2);
+	netmsg_init(&msg.nm_netmsg, so1, &curthread->td_msgport,
+		    0, netmsg_pru_connect2);
 	msg.nm_prufn = so1->so_proto->pr_usrreqs->pru_connect2;
 	msg.nm_so1 = so1;
 	msg.nm_so2 = so2;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so1->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
 int
 so_pru_control(struct socket *so, u_long cmd, caddr_t data, struct ifnet *ifp)
 {
-	return ((*so->so_proto->pr_usrreqs->pru_control)(so, cmd, data, ifp,
-	    curthread));
+	return ((*so->so_proto->pr_usrreqs->pru_control)(
+			so, cmd, data, ifp, curthread));
 #ifdef gag	/* does copyin and copyout deep inside stack XXX JH */
 	int error;
 	struct netmsg_pru_control msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_CONTROL);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_control);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_control);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_control;
-	msg.nm_so = so;
 	msg.nm_cmd = cmd;
 	msg.nm_data = data;
 	msg.nm_ifp = ifp;
 	msg.nm_td = td;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 #endif
 }
@@ -227,14 +209,11 @@ so_pru_detach(struct socket *so)
 {
 	int error;
 	struct netmsg_pru_detach msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_DETACH);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_detach);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_detach);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_detach;
-	msg.nm_so = so;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
@@ -243,14 +222,11 @@ so_pru_disconnect(struct socket *so)
 {
 	int error;
 	struct netmsg_pru_disconnect msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_DISCONNECT);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_disconnect);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_disconnect);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_disconnect;
-	msg.nm_so = so;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
@@ -259,15 +235,12 @@ so_pru_listen(struct socket *so, struct thread *td)
 {
 	int error;
 	struct netmsg_pru_listen msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_LISTEN);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_listen);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_listen);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_listen;
-	msg.nm_so = so;
 	msg.nm_td = td;		/* used only for prison_ip() XXX JH */
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
@@ -276,15 +249,12 @@ so_pru_peeraddr(struct socket *so, struct sockaddr **nam)
 {
 	int error;
 	struct netmsg_pru_peeraddr msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_PEERADDR);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_peeraddr);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_peeraddr);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_peeraddr;
-	msg.nm_so = so;
 	msg.nm_nam = nam;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
@@ -293,15 +263,12 @@ so_pru_rcvd(struct socket *so, int flags)
 {
 	int error;
 	struct netmsg_pru_rcvd msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_RCVD);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_rcvd);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_rcvd);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_rcvd;
-	msg.nm_so = so;
 	msg.nm_flags = flags;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
@@ -310,37 +277,38 @@ so_pru_rcvoob(struct socket *so, struct mbuf *m, int flags)
 {
 	int error;
 	struct netmsg_pru_rcvoob msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_RCVOOB);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_rcvoob);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_rcvoob);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_rcvoob;
-	msg.nm_so = so;
 	msg.nm_m = m;
 	msg.nm_flags = flags;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
+/*
+ * NOTE: so_pru_send() is the only code which uses pr_mport() now.
+ *
+ * NOTE: If the target port changes the implied connect will deal with it.
+ */
 int
-so_pru_send(struct socket *so, int flags, struct mbuf *m, struct sockaddr *addr,
-    struct mbuf *control, struct thread *td)
+so_pru_send(struct socket *so, int flags, struct mbuf *m,
+	    struct sockaddr *addr, struct mbuf *control, struct thread *td)
 {
 	int error;
 	struct netmsg_pru_send msg;
 	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, addr, &m, PRU_SEND);
+	port = so->so_proto->pr_mport(so, addr, &m);
 	if (port == NULL) {
 		KKASSERT(m == NULL);
 		return EINVAL;
 	}
 
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_send);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_send);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_send;
-	msg.nm_so = so;
 	msg.nm_flags = flags;
 	msg.nm_m = m;
 	msg.nm_addr = addr;
@@ -358,15 +326,12 @@ so_pru_sense(struct socket *so, struct stat *sb)
 {
 	int error;
 	struct netmsg_pru_sense msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_SENSE);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_sense);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_sense);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_sense;
-	msg.nm_so = so;
 	msg.nm_stat = sb;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
@@ -375,14 +340,11 @@ so_pru_shutdown(struct socket *so)
 {
 	int error;
 	struct netmsg_pru_shutdown msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_SHUTDOWN);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_shutdown);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_shutdown);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_shutdown;
-	msg.nm_so = so;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
@@ -391,15 +353,12 @@ so_pru_sockaddr(struct socket *so, struct sockaddr **nam)
 {
 	int error;
 	struct netmsg_pru_sockaddr msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_SOCKADDR);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_sockaddr);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_sockaddr);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_sockaddr;
-	msg.nm_so = so;
 	msg.nm_nam = nam;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
@@ -408,17 +367,14 @@ so_pru_sopoll(struct socket *so, int events, struct ucred *cred)
 {
 	int error;
 	struct netmsg_pru_sopoll msg;
-	lwkt_port_t port;
 
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_SOPOLL);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_sopoll);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_sopoll);
 	msg.nm_prufn = so->so_proto->pr_usrreqs->pru_sopoll;
-	msg.nm_so = so;
 	msg.nm_events = events;
 	msg.nm_cred = cred;
 	msg.nm_td = curthread;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
@@ -426,18 +382,15 @@ int
 so_pru_ctloutput(struct socket *so, struct sockopt *sopt)
 {
 	struct netmsg_pru_ctloutput msg;
-	lwkt_port_t port;
 	int error;
 
 	KKASSERT(!sopt->sopt_val || kva_p(sopt->sopt_val));
-	port = so->so_proto->pr_mport(so, NULL, NULL, PRU_CTLOUTPUT);
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_ctloutput);
+	netmsg_init(&msg.nm_netmsg, so, &curthread->td_msgport,
+		    0, netmsg_pru_ctloutput);
 	/* TBD: move pr_ctloutput to pr_usrreqs */
 	msg.nm_prufn = so->so_proto->pr_ctloutput;
-	msg.nm_so = so;
 	msg.nm_sopt = sopt;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, 0);
+	error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, 0);
 	return (error);
 }
 
@@ -463,8 +416,8 @@ so_pru_ctlinput(struct protosw *pr, int cmd, struct sockaddr *arg, void *extra)
 	port = pr->pr_ctlport(cmd, arg, extra);
 	if (port == NULL)
 		return;
-	netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-		    netmsg_pru_ctlinput);
+	netmsg_init(&msg.nm_netmsg, NULL, &curthread->td_msgport,
+		    0, netmsg_pru_ctlinput);
 	msg.nm_prufn = pr->pr_ctlinput;
 	msg.nm_cmd = cmd;
 	msg.nm_arg = arg;
@@ -486,7 +439,7 @@ void
 netmsg_pru_abort(netmsg_t msg)
 {
 	struct netmsg_pru_abort *nm = (void *)msg;
-	struct socket *so = nm->nm_so;
+	struct socket *so = msg->nm_so;
 	int error;
 
 	KKASSERT(so->so_state & SS_ABORTING);
@@ -503,7 +456,7 @@ netmsg_pru_accept(netmsg_t msg)
 {
 	struct netmsg_pru_accept *nm = (void *)msg;
 
-	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(nm->nm_so, nm->nm_nam));
+	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(msg->nm_so, nm->nm_nam));
 }
 #endif
 
@@ -513,7 +466,7 @@ netmsg_pru_attach(netmsg_t msg)
 	struct netmsg_pru_attach *nm = (void *)msg;
 
 	lwkt_replymsg(&msg->nm_lmsg,
-		      nm->nm_prufn(nm->nm_so, nm->nm_proto, nm->nm_ai));
+		      nm->nm_prufn(msg->nm_so, nm->nm_proto, nm->nm_ai));
 }
 
 void
@@ -522,7 +475,7 @@ netmsg_pru_bind(netmsg_t msg)
 	struct netmsg_pru_bind *nm = (void *)msg;
 
 	lwkt_replymsg(&msg->nm_lmsg,
-		      nm->nm_prufn(nm->nm_so, nm->nm_nam, nm->nm_td));
+		      nm->nm_prufn(msg->nm_so, nm->nm_nam, nm->nm_td));
 }
 
 void
@@ -531,7 +484,7 @@ netmsg_pru_connect(netmsg_t msg)
 	struct netmsg_pru_connect *nm = (void *)msg;
 
 	lwkt_replymsg(&msg->nm_lmsg,
-		      nm->nm_prufn(nm->nm_so, nm->nm_nam, nm->nm_td));
+		      nm->nm_prufn(msg->nm_so, nm->nm_nam, nm->nm_td));
 }
 
 void
@@ -548,7 +501,7 @@ netmsg_pru_control(netmsg_t msg)
 	struct netmsg_pru_control *nm = (void *)msg;
 	int error;
 
-	error = nm->nm_prufn(nm->nm_so, nm->nm_cmd, nm->nm_data,
+	error = nm->nm_prufn(msg->nm_so, nm->nm_cmd, nm->nm_data,
 				nm->nm_ifp, nm->nm_td);
 	lwkt_replymsg(&msg->nm_lmsg, error);
 }
@@ -558,7 +511,7 @@ netmsg_pru_detach(netmsg_t msg)
 {
 	struct netmsg_pru_detach *nm = (void *)msg;
 
-	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(nm->nm_so));
+	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(msg->nm_so));
 }
 
 void
@@ -566,7 +519,7 @@ netmsg_pru_disconnect(netmsg_t msg)
 {
 	struct netmsg_pru_disconnect *nm = (void *)msg;
 
-	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(nm->nm_so));
+	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(msg->nm_so));
 }
 
 void
@@ -574,7 +527,7 @@ netmsg_pru_listen(netmsg_t msg)
 {
 	struct netmsg_pru_listen *nm = (void *)msg;
 
-	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(nm->nm_so, nm->nm_td));
+	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(msg->nm_so, nm->nm_td));
 }
 
 void
@@ -582,7 +535,7 @@ netmsg_pru_peeraddr(netmsg_t msg)
 {
 	struct netmsg_pru_peeraddr *nm = (void *)msg;
 
-	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(nm->nm_so, nm->nm_nam));
+	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(msg->nm_so, nm->nm_nam));
 }
 
 void
@@ -590,7 +543,7 @@ netmsg_pru_rcvd(netmsg_t msg)
 {
 	struct netmsg_pru_rcvd *nm = (void *)msg;
 
-	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(nm->nm_so, nm->nm_flags));
+	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(msg->nm_so, nm->nm_flags));
 }
 
 void
@@ -599,7 +552,7 @@ netmsg_pru_rcvoob(netmsg_t msg)
 	struct netmsg_pru_rcvoob *nm = (void *)msg;
 
 	lwkt_replymsg(&msg->nm_lmsg,
-		      nm->nm_prufn(nm->nm_so, nm->nm_m, nm->nm_flags));
+		      nm->nm_prufn(msg->nm_so, nm->nm_m, nm->nm_flags));
 }
 
 void
@@ -608,7 +561,7 @@ netmsg_pru_send(netmsg_t msg)
 	struct netmsg_pru_send *nm = (void *)msg;
 	int error;
 
-	error = nm->nm_prufn(nm->nm_so, nm->nm_flags, nm->nm_m,
+	error = nm->nm_prufn(msg->nm_so, nm->nm_flags, nm->nm_m,
 				nm->nm_addr, nm->nm_control, nm->nm_td);
 	lwkt_replymsg(&msg->nm_lmsg, error);
 }
@@ -618,7 +571,7 @@ netmsg_pru_sense(netmsg_t msg)
 {
 	struct netmsg_pru_sense *nm = (void *)msg;
 
-	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(nm->nm_so, nm->nm_stat));
+	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(msg->nm_so, nm->nm_stat));
 }
 
 void
@@ -626,7 +579,7 @@ netmsg_pru_shutdown(netmsg_t msg)
 {
 	struct netmsg_pru_shutdown *nm = (void *)msg;
 
-	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(nm->nm_so));
+	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(msg->nm_so));
 }
 
 void
@@ -634,7 +587,7 @@ netmsg_pru_sockaddr(netmsg_t msg)
 {
 	struct netmsg_pru_sockaddr *nm = (void *)msg;
 
-	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(nm->nm_so, nm->nm_nam));
+	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(msg->nm_so, nm->nm_nam));
 }
 
 void
@@ -643,7 +596,7 @@ netmsg_pru_sopoll(netmsg_t msg)
 	struct netmsg_pru_sopoll *nm = (void *)msg;
 	int error;
 
-	error = nm->nm_prufn(nm->nm_so, nm->nm_events, nm->nm_cred, nm->nm_td);
+	error = nm->nm_prufn(msg->nm_so, nm->nm_events, nm->nm_cred, nm->nm_td);
 	lwkt_replymsg(&msg->nm_lmsg, error);
 }
 
@@ -652,7 +605,7 @@ netmsg_pru_ctloutput(netmsg_t msg)
 {
 	struct netmsg_pru_ctloutput *nm = (void *)msg;
 
-	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(nm->nm_so, nm->nm_sopt));
+	lwkt_replymsg(&msg->nm_lmsg, nm->nm_prufn(msg->nm_so, nm->nm_sopt));
 }
 
 void
@@ -718,8 +671,8 @@ netmsg_so_notify_doabort(lwkt_msg_t lmsg)
 	struct netmsg_so_notify_abort msg;
 
 	if ((lmsg->ms_flags & (MSGF_DONE | MSGF_REPLY)) == 0) {
-		netmsg_init(&msg.nm_netmsg, &curthread->td_msgport, 0,
-			    netmsg_so_notify_abort);
+		netmsg_init(&msg.nm_netmsg, NULL, &curthread->td_msgport,
+			    0, netmsg_so_notify_abort);
 		msg.nm_notifymsg = (void *)lmsg;
 		lwkt_domsg(lmsg->ms_target_port, &msg.nm_netmsg.nm_lmsg, 0);
 	}
diff --git a/sys/kern/uipc_socket.c b/sys/kern/uipc_socket.c
index 3f91b79..900172e 100644
--- a/sys/kern/uipc_socket.c
+++ b/sys/kern/uipc_socket.c
@@ -189,6 +189,14 @@ socreate(int dom, struct socket **aso, int type,
 	if (so == 0)
 		return (ENOBUFS);
 
+	/*
+	 * Set a default port for protocol processing.  No action will occur
+	 * on the socket on this port until an inpcb is attached to it and
+	 * is able to match incoming packets, or until the socket becomes
+	 * available to userland.
+	 */
+	so->so_port = cpu0_soport(so, NULL, NULL);
+
 	TAILQ_INIT(&so->so_incomp);
 	TAILQ_INIT(&so->so_comp);
 	so->so_type = type;
@@ -197,6 +205,7 @@ socreate(int dom, struct socket **aso, int type,
 	ai.sb_rlimit = &p->p_rlimit[RLIMIT_SBSIZE];
 	ai.p_ucred = p->p_ucred;
 	ai.fd_rdir = p->p_fd->fd_rdir;
+
 	/*
 	 * Auto-sizing of socket buffers is managed by the protocols and
 	 * the appropriate flags must be set in the pru_attach function.
@@ -207,6 +216,7 @@ socreate(int dom, struct socket **aso, int type,
 		sofree(so);
 		return (error);
 	}
+
 	*aso = so;
 	return (0);
 }
@@ -530,6 +540,7 @@ sosend(struct socket *so, struct sockaddr *addr, struct uio *uio,
 		resid = uio->uio_resid;
 	else
 		resid = (size_t)top->m_pkthdr.len;
+
 	/*
 	 * WARNING!  resid is unsigned, space and len are signed.  space
 	 * 	     can wind up negative if the sockbuf is overcommitted.
@@ -555,6 +566,7 @@ restart:
 	error = ssb_lock(&so->so_snd, SBLOCKWAIT(flags));
 	if (error)
 		goto out;
+
 	do {
 		crit_enter();
 		if (so->so_state & SS_CANTSENDMORE)
diff --git a/sys/kern/uipc_socket2.c b/sys/kern/uipc_socket2.c
index c2020b2..c0918a3 100644
--- a/sys/kern/uipc_socket2.c
+++ b/sys/kern/uipc_socket2.c
@@ -218,6 +218,17 @@ soisdisconnected(struct socket *so)
 }
 
 /*
+ * Set or change the message port a socket receives commands on.
+ *
+ * XXX
+ */
+void
+sosetport(struct socket *so, lwkt_port_t port)
+{
+	so->so_port = port;
+}
+
+/*
  * When an attempt at a new connection is noted on a socket
  * which accepts connections, sonewconn is called.  If the
  * connection is possible (subject to space constraints, etc.)
@@ -255,6 +266,7 @@ sonewconn(struct socket *head, int connstatus)
 		sodealloc(so);
 		return (NULL);
 	}
+	KKASSERT(so->so_port != NULL);
 	so->so_rcv.ssb_lowat = head->so_rcv.ssb_lowat;
 	so->so_snd.ssb_lowat = head->so_snd.ssb_lowat;
 	so->so_rcv.ssb_timeo = head->so_rcv.ssb_timeo;
diff --git a/sys/kern/uipc_syscalls.c b/sys/kern/uipc_syscalls.c
index 295b00c..c53f728 100644
--- a/sys/kern/uipc_syscalls.c
+++ b/sys/kern/uipc_syscalls.c
@@ -255,7 +255,6 @@ kern_accept(int s, int fflags, struct sockaddr **name, int *namelen, int *res)
 	struct sockaddr *sa;
 	struct socket *head, *so;
 	struct netmsg_so_notify msg;
-	lwkt_port_t port;
 	int fd;
 	u_int fflag;		/* type must match fp->f_flag */
 	int error, tmp;
@@ -287,16 +286,13 @@ kern_accept(int s, int fflags, struct sockaddr **name, int *namelen, int *res)
 		fflags = lfp->f_flag;
 
 	/* optimize for uniprocessor case later XXX JH */
-	port = head->so_proto->pr_mport(head, NULL, NULL, PRU_PRED);
-	netmsg_init_abortable(&msg.nm_netmsg, &curthread->td_msgport,
-			      0,
-			      netmsg_so_notify,
-			      netmsg_so_notify_doabort);
+	netmsg_init_abortable(&msg.nm_netmsg, head, &curthread->td_msgport,
+			      0, netmsg_so_notify, netmsg_so_notify_doabort);
 	msg.nm_predicate = soaccept_predicate;
 	msg.nm_fflags = fflags;
 	msg.nm_so = head;
 	msg.nm_etype = NM_REVENT;
-	error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, PCATCH);
+	error = lwkt_domsg(head->so_port, &msg.nm_netmsg.nm_lmsg, PCATCH);
 	if (error)
 		goto done;
 
@@ -483,10 +479,8 @@ kern_connect(int s, int fflags, struct sockaddr *sa)
 	}
 	if ((so->so_state & SS_ISCONNECTING) && so->so_error == 0) {
 		struct netmsg_so_notify msg;
-		lwkt_port_t port;
 
-		port = so->so_proto->pr_mport(so, sa, NULL, PRU_PRED);
-		netmsg_init_abortable(&msg.nm_netmsg, 
+		netmsg_init_abortable(&msg.nm_netmsg, so,
 				      &curthread->td_msgport,
 				      0,
 				      netmsg_so_notify,
@@ -494,7 +488,7 @@ kern_connect(int s, int fflags, struct sockaddr *sa)
 		msg.nm_predicate = soconnected_predicate;
 		msg.nm_so = so;
 		msg.nm_etype = NM_REVENT;
-		error = lwkt_domsg(port, &msg.nm_netmsg.nm_lmsg, PCATCH);
+		error = lwkt_domsg(so->so_port, &msg.nm_netmsg.nm_lmsg, PCATCH);
 		if (error == EINTR || error == ERESTART)
 			interrupted = 1;
 	}
diff --git a/sys/kern/uipc_usrreq.c b/sys/kern/uipc_usrreq.c
index 45479a7..9170df4 100644
--- a/sys/kern/uipc_usrreq.c
+++ b/sys/kern/uipc_usrreq.c
@@ -583,6 +583,7 @@ unp_attach(struct socket *so, struct pru_attach_info *ai)
 	LIST_INSERT_HEAD(so->so_type == SOCK_DGRAM ? &unp_dhead
 			 : &unp_shead, unp, unp_link);
 	so->so_pcb = (caddr_t)unp;
+	so->so_port = sync_soport(so, NULL, NULL);
 	return (0);
 }
 
diff --git a/sys/net/bpf.c b/sys/net/bpf.c
index b85999b..2924a28 100644
--- a/sys/net/bpf.c
+++ b/sys/net/bpf.c
@@ -576,8 +576,8 @@ bpfwrite(struct dev_write_args *ap)
 	if (d->bd_hdrcmplt)
 		dst.sa_family = pseudo_AF_HDRCMPLT;
 
-	netmsg_init(&bmsg.nm_netmsg, &curthread->td_msgport, MSGF_MPSAFE,
-		    bpf_output_dispatch);
+	netmsg_init(&bmsg.nm_netmsg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, bpf_output_dispatch);
 	bmsg.nm_mbuf = m;
 	bmsg.nm_ifp = ifp;
 	bmsg.nm_dst = &dst;
